/*
 * Scratchbox Remote Shell
 * Copyright (c) 2003 Timo Savola <timo.savola@movial.fi>
 *
 * sbrsh is licensed under GPL.
 * You can read the full license at http://www.gnu.org/licenses/gpl.txt
 */

#ifndef COMMON_H
#define COMMON_H

#include "types.h"

/** Default port number. */
#define DEFAULT_PORT  1202

/** Maximum username length including the nul-terminator. */
#define USER_SIZE       16

/** Maximum password length including the nul-terminator. */
#define PWD_SIZE        16

/** Maximum hostname length including the nul-terminator. */
#define HOST_SIZE      256

#define MTYPE_NFS_S    "nfs"
#define MTYPE_BIND_S   "bind"

extern int set_nonblocking(int fd, bool_t nonblock);
extern int set_closeonexec(int fd);
extern int setsockopt_bool(int s, int level, int optname, bool_t value);
extern char *get_progname(char *name);
extern void free_vec(void **vec);
extern ssize_t read_line(FILE *file, char *buf, size_t size);
extern char *skip_spaces(char *str);
extern char *find_space(char *str);
extern char *find_line(char *str);
extern char *trim_string(char *str);
extern int split_string(char *line, ...);
extern size_t string_cat(char *buf, size_t bufsize, const char *piece, ...);

/** "Out of memory" */
extern const char *oom;

/* This is defined in client.c and daemon.c */
void error(const char *msg, ...);

#endif
